package org.bitbucket.bradleysmithllc.etlunit.maven.util;

import com.sun.codemodel.*;

import java.util.ArrayList;
import java.util.List;

public class JavaSource {
	private final String className;
	private final String id;

	private final List<JavaProperty> properties = new ArrayList<JavaProperty>();

	public JavaSource(String className) {
		this(className, null);
	}

	public JavaSource(String className, String id) {
		this.className = className;
		this.id = id;
	}

	public void addProperty(JavaProperty property)
	{
		properties.add(property);
	}

	public JDefinedClass toSource(JClassContainer cm) throws JClassAlreadyExistsException
	{
		JDefinedClass dc = cm._class(className);

		if (id != null)
		{
			JFieldVar idp = dc.field(JMod.FINAL | JMod.PUBLIC | JMod.STATIC, String.class, "identitifer");
			idp.init(JExpr.lit(id));
		}

		for (JavaProperty property : properties)
		{
			property.append(dc);
		}

		return dc;
	}
}
